# Interface DeepClientInstance<L>

interface DeepClientInstance<L> {
DeepContext: Context<DeepClient<Link<number>>>;
DeepProvider: ((__namedParameters) => Element);
apolloClient: IApolloClient<any>;
deep: DeepClientInstance<L>;
defaultDeleteName?: string;
defaultInsertName?: string;
defaultSelectName?: string;
defaultUpdateName?: string;
deleteReturning?: string;
filesSelectReturning?: string;
handleAuth?: ((linkId?, token?) => any);
insertReturning?: string;
linkId?: number;
linksSelectReturning?: string;
minilinks: MinilinksResult<L>;
returning?: string;
selectReturning?: string;
selectorsSelectReturning?: string;
table?: string;
token?: string;
unsafe?: any;
updateReturning?: string;
useDeep: (() => DeepClient<Link<number>>);
useDeepQuery: (<Table, LL>(query, options?) => {
data?: LL[];
error?: any;
loading: boolean;
});
useDeepSubscription: (<Table, LL>(query, options?) => UseDeepSubscriptionResult<LL>);
useMinilinksQuery: ((query) => L[]);
useMinilinksSubscription: ((query) => L[]);
valuesSelectReturning?: string;
Traveler(links): Traveler;
await(id): Promise<boolean>;
can(objectIds, subjectIds, actionIds): Promise<boolean>;
delete<TTable>(exp, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
guest(options): Promise<DeepClientAuthResult>;
id(start, ...path): Promise<number>;
idLocal(start, ...path): number;
insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
jwt(options): Promise<DeepClientAuthResult>;
login(options): Promise<DeepClientAuthResult>;
logout(): Promise<DeepClientAuthResult>;
reserve<LL>(count): Promise<number[]>;
select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>;
serial(options): Promise<DeepClientResult<{
id: any;
}[]>>;
serializeQuery(exp, env?): any;
serializeWhere(exp, env?): any;
stringify(any?): string;
subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>;
update<TTable>(exp, value, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
}

#### Type Parameters

- #### L extends Link<number> = Link<number>

#### Implemented by

- DeepClient

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:35

#####
Index

### Properties

DeepContext
DeepProvider
apolloClient
deep
defaultDeleteName?
defaultInsertName?
defaultSelectName?
defaultUpdateName?
deleteReturning?
filesSelectReturning?
handleAuth?
insertReturning?
linkId?
linksSelectReturning?
minilinks
returning?
selectReturning?
selectorsSelectReturning?
table?
token?
unsafe?
updateReturning?
useDeep
useDeepQuery
useDeepSubscription
useMinilinksQuery
useMinilinksSubscription
valuesSelectReturning?

### Methods

Traveler
await
can
delete
guest
id
idLocal
insert
jwt
login
logout
reserve
select
serial
serializeQuery
serializeWhere
stringify
subscribe
update

## Properties

### DeepContext

DeepContext: Context<DeepClient<Link<number>>>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:103

### DeepProvider

DeepProvider: ((__namedParameters) => Element)

#### Type declaration

- - (__namedParameters): Element

  - #### Parameters

    - ##### __namedParameters: {
      apolloClient?: IApolloClient<any>;
      children: any;
      }

      - ##### `Optional` apolloClient?: IApolloClient<any>

      - ##### children: any

    #### Returns Element

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:102

### apolloClient

apolloClient: IApolloClient<any>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:42

### deep

deep: DeepClientInstance<L>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:40

### `Optional` defaultDeleteName

defaultDeleteName?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:59

### `Optional` defaultInsertName

defaultInsertName?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:57

### `Optional` defaultSelectName

defaultSelectName?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:56

### `Optional` defaultUpdateName

defaultUpdateName?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:58

### `Optional` deleteReturning

deleteReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:54

### `Optional` filesSelectReturning

filesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:51

### `Optional` handleAuth

handleAuth?: ((linkId?, token?) => any)

#### Type declaration

- - (linkId?, token?): any

  - #### Parameters

    - ##### `Optional` linkId: number

    - ##### `Optional` token: string

    #### Returns any

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:38

### `Optional` insertReturning

insertReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:52

### `Optional` linkId

linkId?: number

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:36

### `Optional` linksSelectReturning

linksSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:48

### minilinks

minilinks: MinilinksResult<L>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:43

### `Optional` returning

returning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:45

### `Optional` selectReturning

selectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:47

### `Optional` selectorsSelectReturning

selectorsSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:50

### `Optional` table

table?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:44

### `Optional` token

token?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:37

### `Optional` unsafe

unsafe?: any

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:61

### `Optional` updateReturning

updateReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:53

### useDeep

useDeep: (() => DeepClient<Link<number>>)

#### Type declaration

- - (): DeepClient<Link<number>>

  - #### Returns DeepClient<Link<number>>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:101

### useDeepQuery

useDeepQuery: (<Table, LL>(query, options?) => {
data?: LL[];
error?: any;
loading: boolean;
})

#### Type declaration

- - <Table, LL>(query, options?): {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

  - #### Type Parameters

    - #### Table extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

    - #### LL = Link<number>

    #### Parameters

    - ##### query: QueryLink

    - ##### `Optional` options: {
      mini?: string;
      name?: string;
      returning?: string;
      table?: Table;
      tableNamePostfix?: string;
      variables?: any;
      }

      - ##### `Optional` mini?: string

      - ##### `Optional` name?: string

      - ##### `Optional` returning?: string

      - ##### `Optional` table?: Table

      - ##### `Optional` tableNamePostfix?: string

      - ##### `Optional` variables?: any

    #### Returns {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

    - ##### `Optional` data?: LL[]

    - ##### `Optional` error?: any

    - ##### loading: boolean

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:98

### useDeepSubscription

useDeepSubscription: (<Table, LL>(query, options?) => UseDeepSubscriptionResult<LL>)

#### Type declaration

- - <Table, LL>(query, options?): UseDeepSubscriptionResult<LL>

  - #### Type Parameters

    - #### Table extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

    - #### LL = Link<number>

    #### Parameters

    - ##### query: QueryLink

    - ##### `Optional` options: {
      mini?: string;
      name?: string;
      returning?: string;
      table?: Table;
      tableNamePostfix?: string;
      variables?: any;
      }

      - ##### `Optional` mini?: string

      - ##### `Optional` name?: string

      - ##### `Optional` returning?: string

      - ##### `Optional` table?: Table

      - ##### `Optional` tableNamePostfix?: string

      - ##### `Optional` variables?: any

    #### Returns UseDeepSubscriptionResult<LL>

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:97

### useMinilinksQuery

useMinilinksQuery: ((query) => L[])

#### Type declaration

- - (query): L[]

  - #### Parameters

    - ##### query: QueryLink

    #### Returns L[]

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:99

### useMinilinksSubscription

useMinilinksSubscription: ((query) => L[])

#### Type declaration

- - (query): L[]

  - #### Parameters

    - ##### query: QueryLink

    #### Returns L[]

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:100

### `Optional` valuesSelectReturning

valuesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:49

## Methods

### Traveler

- Traveler(links): Traveler

- #### Parameters

  - ##### links: Link<number>[]

  #### Returns Traveler

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:105

### await

- await(id): Promise<boolean>

- #### Parameters

  - ##### id: number

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:78

### can

- can(objectIds, subjectIds, actionIds): Promise<boolean>

- #### Parameters

  - ##### objectIds: number[]

  - ##### subjectIds: number[]

  - ##### actionIds: number[]

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:95

### delete

- delete<TTable>(exp, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:72

### guest

- guest(options): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientGuestOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:87

### id

- id(start, ...path): Promise<number>

- #### Parameters

  - ##### start: QueryLink | DeepClientStartItem

  - ##### `Rest` ...path: DeepClientPathItem[]

  #### Returns Promise<number>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:84

### idLocal

- idLocal(start, ...path): number

- #### Parameters

  - ##### start: DeepClientStartItem

  - ##### `Rest` ...path: DeepClientPathItem[]

  #### Returns number

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:85

### insert

- insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  - #### LL = L

  #### Parameters

  - ##### objects: InsertObjects<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:68

### jwt

- jwt(options): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:89

### login

- login(options): Promise<DeepClientAuthResult>

- #### Parameters

  - ##### options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:91

### logout

- logout(): Promise<DeepClientAuthResult>

- #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:93

### reserve

- reserve<LL>(count): Promise<number[]>

- #### Type Parameters

  - #### LL = L

  #### Parameters

  - ##### count: number

  #### Returns Promise<number[]>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:76

### select

- select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

  - #### LL = L

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: ReadOptions<TTable>

  #### Returns Promise<DeepClientResult<number | LL[]>>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:65

### serial

- serial(options): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Parameters

  - ##### options: AsyncSerialParams

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:74

### serializeQuery

- serializeQuery(exp, env?): any

- #### Parameters

  - ##### exp: any

  - ##### `Optional` env: string

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:82

### serializeWhere

- serializeWhere(exp, env?): any

- #### Parameters

  - ##### exp: any

  - ##### `Optional` env: string

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:81

### stringify

- stringify(any?): string

- #### Parameters

  - ##### `Optional` any: any

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:63

### subscribe

- subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings" | "can" | "selectors" | "tree" | "handlers"

  - #### LL = L

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### `Optional` options: ReadOptions<TTable>

  #### Returns Observable<number | LL[]>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:66

### update

- update<TTable>(exp, value, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - #### TTable extends "objects" | "links" | "numbers" | "strings"

  #### Parameters

  - ##### exp: Exp<TTable>

  - ##### value: UpdateValue<TTable>

  - ##### `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/cyber.tsx:70

Generated using TypeDoc